Index: /trunk/src/org/expeditee/items/Item.java
===================================================================
--- /trunk/src/org/expeditee/items/Item.java	(revision 1101)
+++ /trunk/src/org/expeditee/items/Item.java	(revision 1102)
@@ -784,5 +909,6 @@
 	 * @return The list of Line IDs that this point is part of.
 	 */
-	public String getLineIDs() {
+	public String getLineIDs()
+	{
 		String lineID = null;
 
@@ -797,5 +923,6 @@
 	}
 
-	public int[] getLinePattern() {
+	public int[] getLinePattern()
+	{
 		return _linePattern;
 	}
@@ -807,5 +934,6 @@
 	 *         Lines have been added.
 	 */
-	public List<Line> getLines() {
+	public List<Line> getLines()
+	{
 		return _lines;
 	}
@@ -818,55 +946,68 @@
 	 *         this Item does not link to anything.
 	 */
-	public String getLink() {
+	public String getLink()
+	{
 		return _link;
 	}
 
-	public String getFormula() {
+	public String getFormula()
+	{
 		return _formula;
 	}
 
-	public boolean hasFormula() {
+	public boolean hasFormula()
+	{
 		return _formula != null;
 	}
 
-	public boolean hasAttributeValuePair() {
+	public boolean hasAttributeValuePair()
+	{
 		return _attributeValuePair != null && _attributeValuePair.hasPair();
 	}
 
-	public void setFormula(String formula) {
+	public void setFormula(String formula)
+	{
 		_formula = formula;
 	}
 
-	public boolean calculate(String formula) {
+	public boolean calculate(String formula)
+	{
 		setFormula(formula);
 		return true;
 	}
 
-	public String getLinkFrameset() {
+	public String getLinkFrameset()
+	{
 		return _link_frameset;
 	}
 
-	public boolean getLinkMark() {
+	public boolean getLinkMark()
+	{
 		return _linkMark;
 	}
 
-	public String getLinkTemplate() {
+	public String getLinkTemplate()
+	{
 		return _link_template;
 	}
 
-	// public int getMaxWidth() {
+	// public int getMaxWidth()
+	// {
 	// return _maxWidth;
 	// }
 
-	public Point getOffset() {
+	public Point getOffset()
+	{
 		return _offset;
 	}
 
-	public String getOwner() {
+	public String getOwner()
+	{
 		return _owner;
 	}
 
-	public Color getPaintBackgroundColor() {
-		Color colorBackground = getBackgroundColor();
+	public Colour getPaintBackgroundColor()
+	{
+		Colour colorBackground = getBackgroundColor();
 		if (colorBackground == null) {
 			if (getParent() != null && getParent().getBackgroundColor() != null)
@@ -884,8 +1025,9 @@
 	 * @return The Color of this item (foreground)
 	 */
-	public final Color getPaintColor() {
+	public final Colour getPaintColor()
+	{
 		// If color is null then get the paint foregroundColor for the frame the
 		// item is on which is a color adjusted to suit the background
-		Color color = getColor();
+		Colour color = getColor();
 
 		if (color == null) {
@@ -893,5 +1035,5 @@
 				return getParent().getPaintForegroundColor();
 
-			Frame current = DisplayIO.getCurrentFrame();
+			Frame current = DisplayController.getCurrentFrame();
 			if (current == null) {
 				return DEFAULT_FOREGROUND;
@@ -903,8 +1045,9 @@
 	}
 
-	public final Color getPaintBorderColor() {
+	public final Colour getPaintBorderColor()
+	{
 		// If color is null then get the paint foregroundColor for the frame the
 		// item is on which is a color adjusted to suit the background
-		Color color = getBorderColor();
+		Colour color = getBorderColor();
 
 		if (color == null) {
@@ -912,5 +1055,5 @@
 				return getParent().getPaintForegroundColor();
 
-			Frame current = DisplayIO.getCurrentFrame();
+			Frame current = DisplayController.getCurrentFrame();
 			if (current == null) {
 				return DEFAULT_FOREGROUND;
@@ -922,6 +1065,7 @@
 	}
 
-	protected Color getPaintHighlightColor() {
-		Color highlightColor = getDefaultHighlightColor();
+	protected Colour getPaintHighlightColor()
+	{
+		Colour highlightColor = getDefaultHighlightColor();
 		if (hasVisibleBorder()) {
 			if (getPaintBorderColor().equals(highlightColor)) {
@@ -931,14 +1075,13 @@
 			highlightColor = getDefaultHighlightColor();
 		}
-		if (getParent() != null
-				&& getParent().getPaintBackgroundColor().equals(highlightColor))
+		
+		if (getParent() != null && getParent().getPaintBackgroundColor().equals(highlightColor)) {
 			highlightColor = getParent().getPaintForegroundColor();
+		}
 
 		if (hasVisibleBorder()) {
-			if (highlightColor.equals(getBorderColor())
-					&& getThickness() == getHighlightThickness()) {
-				highlightColor = new Color(highlightColor.getRed(),
-						highlightColor.getGreen(), highlightColor.getBlue(),
-						150);
+			if (highlightColor.equals(getBorderColor()) && getThickness() == getHighlightThickness()) {
+				highlightColor = highlightColor.clone();
+				highlightColor.setAlpha(Colour.FromComponent255(150));
 			}
 		}
@@ -947,35 +1090,35 @@
 	}
 
-	static final int BRIGHTNESS = 185;
-
-	protected Color getDefaultHighlightColor() {
-		if (isVectorItem()
-				&& !this.contains(FrameMouseActions.getX(), FrameMouseActions
-						.getY())) {
-			return new Color(255, BRIGHTNESS, BRIGHTNESS);
-		}
-		return _highlightColor;
-	}
-
-	protected Color getAlternateHighlightColor() {
-		if (isVectorItem()
-				&& !this.contains(FrameMouseActions.getX(), FrameMouseActions
-						.getY())) {
-			return new Color(BRIGHTNESS, BRIGHTNESS, 255);
+	protected Colour getDefaultHighlightColor()
+	{
+		if (isVectorItem() && !this.contains(EcosystemManager.getInputManager().getCursorPosition())) {
+			return Colour.FromRGB255(255, BRIGHTNESS, BRIGHTNESS);
+		}
+		return _highlightColour;
+	}
+
+	protected Colour getAlternateHighlightColor()
+	{
+		if (isVectorItem() && !this.contains(EcosystemManager.getInputManager().getCursorPosition())) {
+			return Colour.FromRGB255(BRIGHTNESS, BRIGHTNESS, 255);
 		}
 		return ALTERNATE_HIGHLIGHT;
 	}
 
-	protected int getHighlightThickness() {
-		if (isVectorItem())
-			return _vectorHighlightThickness;
+	protected int getHighlightThickness()
+	{
+		if (isVectorItem()) return _vectorHighlightThickness;
+		
 		return _highlightThickness;
 	}
 
-	public final Frame getParent() {
+	public final Frame getParent()
+	{
 		return _parent;
 	}
 
-	public final Point getPosition() {
+	/** Gets the position of this item. */
+	public final Point getPosition()
+	{
 		return new Point(getX(), getY());
 	}
@@ -987,6 +1130,7 @@
 	 * @return The size of this Item.
 	 */
-	public float getSize() {
-		return -1.0F;
+	public float getSize()
+	{
+		return SIZE_NOT_APPLICABLE;
 	}
 
@@ -997,21 +1141,26 @@
 	 * @return The Color displayed on the top\left half of this Item's border.
 	 */
-	public Color getTopShadowColor() {
+	public Colour getTopShadowColor()
+	{
 		return _colorTopShadow;
 	}
 
-	public String getTypeAndID() {
+	public String getTypeAndID()
+	{
 		return "T " + getID();
 	}
 
-	public Integer getWidthToSave() {
+	public Integer getWidthToSave()
+	{
 		return getWidth();
 	}
 
-	public Integer getWidth() {
+	public Integer getWidth()
+	{
 		return null;
 	}
 
-	public int getHeight() {
+	public int getHeight()
+	{
 		return 0;
 	}
@@ -1022,5 +1171,6 @@
 	 * @return The X coordinate of this Item on the screen
 	 */
-	public int getX() {
+	public int getX()
+	{
 		return Math.round(_x);
 	}
@@ -1031,9 +1181,11 @@
 	 * @return The Y coordinate of this Item on the screen
 	 */
-	public int getY() {
+	public int getY()
+	{
 		return Math.round(_y);
 	}
 
-	public boolean hasVisibleArrow() {
+	public boolean hasVisibleArrow()
+	{
 		return isLineEnd() && getArrowheadRatio() != 0 && getArrowheadLength() != 0;
 	}
@@ -1046,19 +1198,18 @@
 	 * @return True if the two Shapes overlap, False otherwise.
 	 */
-	public boolean intersects(Polygon p) {
-		if (p == null)
-			return false;
-
-		Area a = new Area(p);
-		Area thisArea = this.getArea();
+	public boolean intersects(PolygonBounds otherBounds)
+	{
+		if (otherBounds == null) return false;
+		
+		Bounds thisBounds = getBounds();
+		
 		// Need to do this check for circles
-		if (a.equals(thisArea))
-			return true;
-
-		a.intersect(thisArea);
+		if (otherBounds.equals(thisBounds)) return true;
+
+		return otherBounds.intersects(thisBounds);
 
 		// Need to check the second equality so that we dont pick up circles
 		// inside other circles
-		return !a.isEmpty() && !a.equals(new Area(p));
+		//return !a.isEmpty() && !a.equals(new Area(p));
 	}
 
@@ -1069,13 +1220,16 @@
 	 * @return True if this Item is an annotation, False otherwise.
 	 */
-	public boolean isAnnotation() {
+	public boolean isAnnotation()
+	{
 		return false;
 	}
 
-	public boolean isFloating() {
+	public boolean isFloating()
+	{
 		return _floating;
 	}
 
-	public boolean isFrameName() {
+	public boolean isFrameName()
+	{
 		if (this.getParent() == null || this.getParent().getNameItem() != this)
 			return false;
@@ -1083,5 +1237,6 @@
 	}
 
-	public boolean isFrameTitle() {
+	public boolean isFrameTitle()
+	{
 		if (this.getParent() == null || this.getParent().getTitleItem() != this)
 			return false;
@@ -1095,8 +1250,9 @@
 	 *         otherwise.
 	 */
-	public boolean isHighlighted() {
+	public boolean isHighlighted()
+	{
 		if (isFloating())
 			return false;
-		return _mode != HighlightMode.None;
+		return _highlightMode != HighlightMode.None;
 	}
 
@@ -1109,5 +1265,6 @@
 	 * @return True if the given framename is proper, false otherwise.
 	 */
-	public boolean isLinkValid() {
+	public boolean isLinkValid()
+	{
 		if (FrameIO.isPositiveInteger(getLink()))
 			return true;
@@ -1118,15 +1275,26 @@
 	}
 
-	public boolean isNear(int x, int y) {
-
-		int xLeft = getPolygon().getBounds().x;
-		int yTop = getPolygon().getBounds().y;
-
-		return (x > xLeft - NEAR_DISTANCE && y > yTop - NEAR_DISTANCE
-				&& x < xLeft + getBoundsWidth() + NEAR_DISTANCE && y < yTop
-				+ getBoundsHeight() + NEAR_DISTANCE);
-	}
-
-	public boolean isOldTag() {
+	/**
+	 * Checks if the given point is 'near' to the item. Here 'near' means within a certain distance
+	 * of the axis-aligned box bounding the item's polygon.
+	 * 
+	 * @param x
+	 * 		The x-coordinate of the point to check.
+	 * 
+	 * @param y
+	 * 		The y-coordinate of the point to check.
+	 * 
+	 * @return
+	 * 		True if the given point is 'near' to the item, false otherwise.
+	 */
+	public boolean isNear(int x, int y)
+	{
+		AxisAlignedBoxBounds box = ItemUtils.expandRectangle(getBoundingBox(), NEAR_DISTANCE * 2);
+		
+		return box.contains(x, y);
+	}
+
+	public boolean isOldTag()
+	{
 		if (this instanceof Text)
 			if (((Text) this).getTextList().get(0).toLowerCase().equals("@old"))
@@ -1153,12 +1321,17 @@
 	 *            The Graphics to draw this Item on.
 	 */
-	public abstract void paint(Graphics2D g);
-	
-	public void setTooltips(final List<String> tooltips) {
-		if(tooltips == null || tooltips.size() == 0) _tooltip = new Tooltip();
-		else for(final String content: tooltips) _tooltip.addTooltip(content, this);
-	}
-	
-	public void setTooltip(final String tooltip) {
+	public abstract void paint();
+	
+	public void setTooltips(final List<String> tooltips)
+	{
+		if (tooltips == null || tooltips.size() == 0) {
+			_tooltip = new Tooltip();
+		} else {
+			for (final String content: tooltips) _tooltip.addTooltip(content, this);
+		}
+	}
+	
+	public void setTooltip(final String tooltip)
+	{
 		if(tooltip != null && tooltip.trim().length() > 0) {
 			_tooltip.addTooltip(tooltip, this);
@@ -1166,79 +1339,92 @@
 	}
 	
-	public List<String> getTooltip() {
+	public List<String> getTooltip()
+	{
 		return _tooltip.asStringList();
 	}
 	
-	public Collection<Text> getTooltipItems() {
+	public Collection<Text> getTooltipItems()
+	{
 		return _tooltip.getTooltips();
 	}
 
-	public void clearTooltips() {
+	public void clearTooltips()
+	{
 		final Frame frame = this.getParent();
-		if(_tooltip != null)
+		if(_tooltip != null) {
 			for(final Text tooltip: _tooltip.getTooltips()) frame.removeItem(tooltip);
-	}
-	
-	public void paintTooltip(final Graphics2D g) {
-		final Rectangle bounds = this.getPolygon().getBounds();
-		int x = bounds.x + bounds.width;
-		if(x + _tooltip.getWidth() > FrameGraphics.getMaxFrameSize().width) {
-			x -= x + _tooltip.getWidth() - FrameGraphics.getMaxFrameSize().width;
-		}
-		int y = bounds.y + bounds.height;
-		if(y + _tooltip.getCollectiveHeight() > FrameGraphics.getMaxFrameSize().height) {
-			y = bounds.y + bounds.height / 2 - _tooltip.getCollectiveHeight();
-		}
+		}
+	}
+	
+	public void paintTooltip()
+	{
+		final Bounds bounds = AxisAlignedBoxBounds.getEnclosing(this.getBoundingBox());
+		Dimension frameSize = DisplayController.getFramePaintArea().getSize();
+		
+		int x = bounds.getMaxX();
+		
+		// If the tooltip goes off the right side of the window, move it left so it's completely on
+		if(x + _tooltip.getWidth() > frameSize.getWidth()) {
+			x = frameSize.getWidth() - _tooltip.getWidth();
+		}
+		
+		int y = bounds.getMaxY();
+		
+		if(y + _tooltip.getCollectiveHeight() > frameSize.getHeight()) {
+			y = (bounds.getMinY() + bounds.getMaxY()) / 2 - _tooltip.getCollectiveHeight();
+		}
+		
 		for(final Text tooltip : _tooltip.getTooltips()) {
 			this.getParent().addItem(tooltip);
 			tooltip.setPosition(x, y);
-			tooltip.paint(g);
+			tooltip.paint();
 			y += tooltip.getHeight();
 		}
 	}
 	
-	public void paintFill(Graphics2D g) {
-		Color fillColor = getFillColor();
+	public void paintFill() {
+		Colour fillColor = getFillColor();
 		if (fillColor != null && getEnclosingDots() != null) {
-			setFillPaint(g);
-			g.fillPolygon(getEnclosedShape());
-		}
-	}
-
-	protected void setFillPaint(Graphics2D g) {
-		Color fillColor = getFillColor();
+			Fill fill = getFill();
+			EcosystemManager.getGraphicsManager().drawPolygon(getEnclosedShape(), null, null, 0.0f, fill, null, null);
+		}
+	}
+
+	protected Fill getFill() {
+		Fill fill;
+		Colour fillColour = getFillColor();
 		if (isFloating()) {
 			// TODO experiment with adding alpha when picking up filled
 			// items... Slows things down quite alot!!
-			fillColor = new Color(fillColor.getRed(), fillColor.getGreen(),
-					fillColor.getBlue(), fillColor.getAlpha());
-		}
-		g.setColor(fillColor);
-		Color gradientColor = getGradientColor();
-		if (gradientColor != null) {
+			// TODO: Does nothing as it stands... cts16
+			fillColour = new Colour(fillColour.getRed(), fillColour.getGreen(),
+					fillColour.getBlue(), fillColour.getAlpha());
+		}
+		Colour gradientColor = getGradientColor();
+		PolygonBounds poly = getEnclosedShape();
+		if (gradientColor != null && poly != null) {
 			/*
 			 * It is slow when painting gradients... modify so this is only done
 			 * once unless it is resized...
 			 */
-			Shape s = getEnclosedShape();
-			if (s != null) {
-				Rectangle b = s.getBounds();
-				double rads = getGradientAngle() * Math.PI / 180;
-				double cos = Math.cos(rads);
-				double sin = Math.sin(rads);
-
-				GradientPaint gp = new GradientPaint((int) (b.x + b.width
-						* (0.2 * cos + 0.5)), (int) (b.y + b.height
-						* (0.2 * sin + 0.5)), fillColor, (int) (b.x + b.width
-						* (-0.8 * cos + 0.5)), (int) (b.y + b.height
-						* (-0.8 * sin + 0.5)), gradientColor);
-				g.setPaint(gp);
-			}
-		}
+			AxisAlignedBoxBounds b = AxisAlignedBoxBounds.getEnclosing(poly);
+			double rads = getGradientAngle();
+			double cos = Math.cos(rads);
+			double sin = Math.sin(rads);
+
+			Point fromPoint = new Point((int) (b.getMinX() + b.getWidth() * (0.2 * cos + 0.5)), (int) (b.getMinY() + b.getHeight() * (0.2 * sin + 0.5)));
+			Point toPoint = new Point((int) (b.getMinX() + b.getWidth() * (-0.8 * cos + 0.5)), (int) (b.getMinY() + b.getHeight() * (-0.8 * sin + 0.5)));
+			
+			fill = new GradientFill(fillColour, fromPoint, gradientColor, toPoint);
+		} else {
+			fill = new Fill(fillColour);
+		}
+		
+		return fill;
 	}
 
 	/**
 	 * This method performs all the actions in an items list. If it contains a
-	 * link as well the link is used as the source frame for all acitons.
+	 * link as well the link is used as the source frame for all actions.
 	 */
 	public void performActions() {
@@ -1268,5 +1454,5 @@
 			// For actions like format they rely on this being set to the
 			// current frame incase the item being activated is on an overlay
-			sourceFrame = DisplayIO.getCurrentFrame();
+			sourceFrame = DisplayController.getCurrentFrame();
 		}
 
@@ -1388,5 +1574,5 @@
 			MessageBay.displayMessage("See SIMPLE doc for ["
 					+ ise.getStatement() + "] statement", ise.getStatement()
-					+ "1", Color.CYAN.darker(), true, null);
+					+ "1", Colour.CYAN.darker(), true, null);
 		} catch (Exception e) {
 			MessageBay.linkedErrorMessage(e.getMessage());
@@ -1394,5 +1580,5 @@
 		Simple.ProgramFinished();
 		// Need to repaint any highlights etc
-		FrameGraphics.requestRefresh(true);
+		DisplayController.requestRefresh(true);
 	}
 
@@ -1414,5 +1600,5 @@
 
 		if (_parent == null)
-			framesetName = DisplayIO.getCurrentFrame().getFramesetName();
+			framesetName = DisplayController.getCurrentFrame().getFramesetName();
 		else
 			framesetName = _parent.getFramesetName();
@@ -1428,14 +1614,15 @@
 	 *            The lines of code to associate with this Item
 	 */
-	public void setActions(List<String> actions) {
+	public void setActions(List<String> actions)
+	{
 		if (actions == null || actions.size() == 0) {
 			invalidateCommonTrait(ItemAppearence.LinkChanged);
 			_actions = null;
-		} else
+		} else {
 			_actions = new LinkedList<String>(actions);
-
-		// Want to resize the highlight box for text items if actions have been
-		// added
-		_poly = null;
+		}
+		
+		// Want to resize the highlight box for text items if actions have been added
+		invalidateBounds();
 		invalidateCommonTrait(ItemAppearence.LinkChanged);
 	}
@@ -1481,11 +1668,10 @@
 	}
 
-	public void setActionMark(boolean val) {
-		if (!val)
-			invalidateCommonTrait(ItemAppearence.LinkChanged);
-		_poly = null;
+	public void setActionMark(boolean val)
+	{
+		if (!val) invalidateCommonTrait(ItemAppearence.LinkChanged);
+		invalidateBounds();
 		_actionMark = val;
-		if (val)
-			invalidateCommonTrait(ItemAppearence.LinkChanged);
+		if (val) invalidateCommonTrait(ItemAppearence.LinkChanged);
 	}
 
@@ -1519,5 +1705,5 @@
 	}
 	
-	public void setArrowhead(Polygon arrow) {
+	public void setArrowhead(PolygonBounds arrow) {
 		_arrowhead = arrow;
 	}
@@ -1538,12 +1724,12 @@
 	}
 
-	public void setBackgroundColor(Color c) {
-		if (c != _colorBackground) {
-			_colorBackground = c;
+	public void setBackgroundColor(Colour c) {
+		if (c != _backgroundColour) {
+			_backgroundColour = c;
 			invalidateCommonTrait(ItemAppearence.BackgroundColorChanged);
 		}
 	}
 
-	public void setBorderColor(Color c) {
+	public void setBorderColor(Colour c) {
 		if (c != _colorBorder) {
 			_colorBorder = c;
@@ -1560,5 +1746,5 @@
 	 *            Item's border.
 	 */
-	public void setBottomShadowColor(Color bottom) {
+	public void setBottomShadowColor(Colour bottom) {
 		_colorBottomShadow = bottom;
 	}
@@ -1569,12 +1755,12 @@
 	 * @param c
 	 */
-	public void setColor(Color c) {
-		if (c != _color) {
-			_color = c;
+	public void setColor(Colour c) {
+		if (c != _foregroundColour) {
+			_foregroundColour = c;
 			invalidateCommonTrait(ItemAppearence.ForegroundColorChanged);
 			if (hasVector()) {
 				// TODO make this more efficient so it only repaints the items
 				// for this vector
-				FrameKeyboardActions.Refresh();
+				StandardGestureActions.Refresh();
 			}
 		}
@@ -1605,7 +1791,7 @@
 	}
 
-	public void setFillColor(Color c) {
-
-		_colorFill = c;
+	public void setFillColor(Colour c) {
+
+		_fillColour = c;
 
 		for (Line line : _lines) {
@@ -1620,6 +1806,7 @@
 	}
 
-	public void setGradientColor(Color c) {
-		_colorGradient = c;
+	public void setGradientColor(Colour c)
+	{
+		_gradientColour = c;
 
 		for (Line line : _lines) {
@@ -1633,6 +1820,6 @@
 	}
 
-	public Color getGradientColor() {
-		return _colorGradient;
+	public Colour getGradientColor() {
+		return _gradientColour;
 	}
 
@@ -1647,4 +1834,10 @@
 	}
 
+	/**
+	 * Sets the value <code>_highlight</code> for this item.
+	 * TODO: Appears unused? cts16
+	 * 
+	 * @param val The new value for <code>_highlight</code>.
+	 */
 	public void setHighlight(boolean val) {
 		_highlight = val;
@@ -1693,19 +1886,17 @@
 	 *            The name of the Frame to link this item to.
 	 */
-	public void setLink(String frameName) {
-		if (frameName == null) {
-			invalidateCommonTrait(ItemAppearence.LinkChanged);
-		}
-
-		// If a link is being removed or set then need to reset poly so the
+	public void setLink(String frameName)
+	{
+		if (frameName == null) invalidateCommonTrait(ItemAppearence.LinkChanged);
+
+		// If a link is being removed or set then need to reset _bounds so the
 		// highlighting is drawn with the correct width
-		if (frameName == null || getLink() == null)
-			_poly = null;
-
-		if (FrameIO.isValidLink(frameName))
+		if (frameName == null || getLink() == null) invalidateBounds();
+
+		if (FrameIO.isValidLink(frameName)) {
 			_link = frameName;
-		else
-			MessageBay.errorMessage("[" + frameName
-					+ "] is not a valid frame name");
+		} else {
+			MessageBay.errorMessage("[" + frameName + "] is not a valid frame name");
+		}
 		// TODO make this throw exceptions etc...
 
@@ -1721,28 +1912,29 @@
 	}
 
-	public void setLinkFrameset(String frameset) {
-		if (frameset == null || FrameIO.isValidFramesetName(frameset))
+	public void setLinkFrameset(String frameset)
+	{
+		if (frameset == null || FrameIO.isValidFramesetName(frameset)) {
 			_link_frameset = frameset;
-		else
-			MessageBay.errorMessage("[" + frameset
-					+ "] is not a valid frameset name");
+		} else {
+			MessageBay.errorMessage("[" + frameset + "] is not a valid frameset name");
+		}
 		// TODO make this throw exceptions etc...
 	}
 
-	public void setLinkMark(boolean val) {
-		if (!val)
-			invalidateCommonTrait(ItemAppearence.LinkChanged);
-		_poly = null;
+	public void setLinkMark(boolean val)
+	{
+		if (!val) invalidateCommonTrait(ItemAppearence.LinkChanged);
+		invalidateBounds();
 		_linkMark = val;
-		if (val)
-			invalidateCommonTrait(ItemAppearence.LinkChanged);
-	}
-
-	public void setLinkTemplate(String template) {
-		if (FrameIO.isValidLink(template))
+		if (val) invalidateCommonTrait(ItemAppearence.LinkChanged);
+	}
+
+	public void setLinkTemplate(String template)
+	{
+		if (FrameIO.isValidLink(template)) {
 			_link_template = template;
-		else
-			MessageBay.errorMessage("[" + template
-					+ "] is not a valid frame name");
+		} else {
+			MessageBay.errorMessage("[" + template + "] is not a valid frame name");
+		}
 		// TODO make this throw exceptions etc...
 	}
@@ -1763,9 +1955,9 @@
 
 	public void setOffset(int x, int y) {
-		_offset.setLocation(x, y);
+		_offset.set(x, y);
 	}
 
 	public void setOffset(Point p) {
-		_offset.setLocation(p);
+		_offset.set(p);
 	}
 
@@ -1805,5 +1997,5 @@
 			}
 		}
-		if (_colorFill != null) {
+		if (_fillColour != null) {
 			invalidateFill(); // only invalidates if has fill
 		}
@@ -1814,8 +2006,4 @@
 	}
 
-	
-	
-	
-	
 	protected void anchorConstraints()
 	{
@@ -1830,12 +2018,10 @@
 					if (isAnchoredY()) {
 						// Make the 'other' item have the same anchor top/bottom values as this
-						other._anchorTop    = _anchorTop;
-						other._anchorBottom = _anchorBottom;
+						other._anchoring.setYAnchor(this._anchoring);
 					}
 				} else if (c.getType() == Constraint.VERTICAL) {
 					if (isAnchoredX()) {
 						// Make the 'other' item have the same anchor left/right values as this
-						other._anchorLeft  = _anchorLeft;
-						other._anchorRight = _anchorRight;
+						other._anchoring.setXAnchor(this._anchoring);
 					}
 				} else if (c.isDiagonal()) {
@@ -1855,10 +2041,10 @@
 	 *            The new Y coordinate
 	 */
-	public void setPosition(float x, float y) {
+	public void setPosition(float x, float y)
+	{
 		float deltaX = x - _x;
 		float deltaY = y - _y;
 
-		if (deltaX == 0 && deltaY == 0)
-			return;
+		if (deltaX == 0 && deltaY == 0) return;
 
 		invalidateCommonTraitForAll(ItemAppearence.PreMoved);
@@ -1868,7 +2054,7 @@
 
 		for (Item i : getEnclosures()) {
-			i.updatePolygon();
-		}
-		updatePolygon();
+			i.invalidateBounds();
+		}
+		invalidateBounds();
 
 		// update the position of any dots that are constrained by this one
@@ -1951,5 +2137,5 @@
 
 		for (Line line : getLines()) {
-			line.updatePolygon();
+			line.invalidateBounds();
 		}
 
@@ -2007,7 +2193,8 @@
 	 *            their thickness set
 	 */
-	public void setThickness(float thick, boolean setConnectedThickness) {
-		if (thick == _thickness)
-			return;
+	public void setThickness(float thick, boolean setConnectedThickness)
+	{
+		if (thick == _thickness) return;
+		
 		boolean bigger = thick > _thickness;
 
@@ -2015,6 +2202,5 @@
 			if (setConnectedThickness) {
 				// TODO is there a more efficient way of doing this?
-				for (Item i : getConnected())
-					i.invalidateCommonTrait(ItemAppearence.Thickness);
+				for (Item i : getConnected()) i.invalidateCommonTrait(ItemAppearence.Thickness);
 			} else {
 				invalidateCommonTrait(ItemAppearence.Thickness);
@@ -2028,14 +2214,11 @@
 		 * etc...
 		 */
-		for (Line line : getLines())
-			line.setThickness(thick, setConnectedThickness);
-
-		if (setConnectedThickness)
-			updatePolygon();
+		for (Line line : getLines()) line.setThickness(thick, setConnectedThickness);
+
+		if (setConnectedThickness) invalidateBounds();
 
 		if (bigger) {
 			if (setConnectedThickness) {
-				for (Item i : getConnected())
-					i.invalidateCommonTrait(ItemAppearence.Thickness);
+				for (Item i : getConnected()) i.invalidateCommonTrait(ItemAppearence.Thickness);
 			} else {
 				invalidateCommonTrait(ItemAppearence.Thickness);
@@ -2050,5 +2233,6 @@
 	 *         set).
 	 */
-	public float getThickness() {
+	public float getThickness()
+	{
 		return _thickness;
 	}
@@ -2062,15 +2246,17 @@
 	 *            Item's border.
 	 */
-	public void setTopShadowColor(Color top) {
+	public void setTopShadowColor(Colour top) {
 		_colorTopShadow = top;
 	}
 
-	public void setWidth(Integer width) throws UnsupportedOperationException {
-		throw new UnsupportedOperationException(
-				"Item type does not support width attribute!");
-	}
-
-	public void setRightMargin(int i, boolean fixWidth) {
+	public void setWidth(Integer width) throws UnsupportedOperationException
+	{
+		throw new UnsupportedOperationException("Item type does not support width attribute!");
+	}
+
+	public void setRightMargin(int i, boolean fixWidth)
+	{
 		int newWidth = i - getX() - Item.MARGIN_LEFT;
+		if (newWidth < 0) newWidth = 0;
 		if (!fixWidth) {
 			newWidth *= -1;
@@ -2113,9 +2299,17 @@
 	 *         means no change)
 	 */
-	public int setHighlightColor() {
-		return setHighlightColor(DEFAULT_HIGHLIGHT);
-	}
-
-	public int setHighlightColor(Color c) {
+	
+	/**
+	 * 
+	 * 
+	 * @return
+	 */
+	public void setHighlightColorToDefault() {
+		setHighlightColor(DEFAULT_HIGHLIGHT);
+	}
+
+	public void setHighlightColor(Colour c) {
+		if (c == null) return;
+		
 		if (!this.isVisible() && this.hasVector()) {
 			for (Item i : this.getParentOrCurrentFrame().getVectorItems()) {
@@ -2128,11 +2322,9 @@
 		_highlightThickness = DEFAULT_HIGHLIGHT_THICKNESS;
 
-		Color selColor = (c != null) ? c : DEFAULT_HIGHLIGHT;
-		if (_highlightColor != c) {
-			_highlightColor = selColor;
+		Colour selColor = (c != null) ? c : DEFAULT_HIGHLIGHT;
+		if (_highlightColour != c) {
+			_highlightColour = selColor;
 			this.invalidateCommonTrait(ItemAppearence.HighlightColorChanged);
 		}
-
-		return Item.UNCHANGED_CURSOR;
 
 	}
@@ -2146,5 +2338,6 @@
 	}
 
-	public abstract void updatePolygon();
+	/** Returns a Bounds which represents the area covered by the item (including its gravity). */
+	public abstract Bounds updateBounds();
 
 	public void setHidden(boolean state) {
@@ -2172,17 +2365,18 @@
 	}
 
-	public void setHighlightMode(HighlightMode mode, Color color) {
-		setHighlightColor(color);
-		if (hasPermission(UserAppliedPermission.followLinks)
-				|| getEditTarget().hasPermission(UserAppliedPermission.followLinks)) {
-			if (_mode != mode) {
-				_mode = mode;
-				this.invalidateCommonTrait(ItemAppearence.HighlightModeChanged);
-			}
-		}
+	/**
+	 * Sets the highlight mode and colour at the same time.
+	 * 
+	 * @param mode The new highlight mode.
+	 * @param colour The new highlight colour.
+	 */
+	public void setHighlightModeAndColour(HighlightMode mode, Colour colour)
+	{
+		setHighlightMode(mode);
+		setHighlightColor(colour);
 	}
 
 	public HighlightMode getHighlightMode() {
-		return _mode;
+		return _highlightMode;
 	}
 
@@ -2191,7 +2385,5 @@
 		// only set the id if we've moved to a different frame, or if the frame already has an item with that id
 		if(!current.equals(_oldParent) || current.getItemWithID(getID()) != null) {
-			int id = _id;
 			setID(current.getNextItemID());
-			// System.out.println(this + " - Set ID to " + _id + " (was " + id + ")");
 		} else {
 			// System.out.println(this + " - Kept old ID of " + _id);
@@ -2239,5 +2431,5 @@
 		// if the item is from an overlay the parent will NOT be null
 		if (getParent() == null) {
-			return DisplayIO.getCurrentFrame();
+			return DisplayController.getCurrentFrame();
 		}
 		return getParent();
@@ -2275,11 +2467,11 @@
 	 *         the enclosed list.
 	 */
-	public Polygon getEnclosedShape() {
-		if (_enclosure == null)
-			return null;
-
-		Polygon poly = new Polygon();
+	public PolygonBounds getEnclosedShape()
+	{
+		if (_enclosure == null) return null;
+
+		PolygonBounds poly = new PolygonBounds();
 		for (Item d : _enclosure) {
-			poly.addPoint(d.getX(), d.getY());
+			poly.addPoint(new Point(d.getX(), d.getY()));
 		}
 
@@ -2332,5 +2524,5 @@
 	 *            the new color for the line
 	 */
-	protected void lineColorChanged(Color c) {
+	protected void lineColorChanged(Colour c) {
 		for (Line l : getLines()) {
 			if (l.getColor() != c)
@@ -2345,17 +2537,20 @@
 	 */
 	public boolean offScreenTopOrLeft() {
-		Rectangle itemRect = getArea().getBounds();
+		Bounds bounds = getBoundingBox();
+		
 		// Check that the bottom right corner of this item is on the screen
-		if (itemRect.x + itemRect.width >= 0
-				&& itemRect.y + itemRect.height >= 0)
+		if (bounds.getMaxX() >= 0 && bounds.getMaxY() >= 0) {
 			return false;
+		}
+		
 		// Check if all the items it is connected to are offscreen
 		for (Item i : getAllConnected()) {
-			Rectangle iRect = i.getArea().getBounds();
+			bounds = i.getBoundingBox();
 			// Check that the bottom right corner of this item is on the screen
-			if (iRect.x + iRect.width >= 0 && iRect.y + iRect.height >= 0) {
+			if (bounds.getMaxX() >= 0 && bounds.getMaxY() >= 0) {
 				return false;
 			}
 		}
+		
 		return true;
 	}
@@ -2374,18 +2569,20 @@
 	}
 
-	public void setAction(String action) {
-		// Want to resize the highlight box for text items if actions are been
-		// added
+	public void setAction(String action)
+	{
+		// Want to resize the highlight box for text items if actions are been added
 		if (action == null || action.length() == 0) {
 			invalidateCommonTrait(ItemAppearence.LinkChanged);
 		}
+		
 		if (_actions == null || _actions.size() == 0) {
-			_poly = null;
+			invalidateBounds();
 			_actions = new LinkedList<String>();
 		} else {
 			_actions.clear();
 		}
-		if (action != null && action.length() > 0)
-			_actions.add(action);
+		
+		if (action != null && action.length() > 0) _actions.add(action);
+		
 		invalidateCommonTrait(ItemAppearence.LinkChanged);
 	}
@@ -2395,5 +2592,5 @@
 	}
 
-	protected Rectangle getLinkDrawArea() {
+	protected AxisAlignedBoxBounds getLinkDrawArea() {
 		return getLinkDrawArea(getX() - LEFT_MARGIN, getY() + getLinkYOffset());
 	}
@@ -2410,6 +2607,6 @@
 	 * @return The drawing area of the link at the given coordinates.
 	 */
-	public Rectangle getLinkDrawArea(int x, int y) {
-		return new Rectangle(x + 2, y - 1, 8, 8);
+	public AxisAlignedBoxBounds getLinkDrawArea(int x, int y) {
+		return new AxisAlignedBoxBounds(x + 2, y - 1, 8, 8);
 	}
 
